maph 1.0.0 High-Performance Memory-Mapped Key-Value Database with O(1) Lookups

Loading...
Searching...
No Matches
Public Member Functions | List of all members
httplib::Client Class Reference

`#include <httplib.h>`

Collaboration diagram for httplib::Client:

## Public Member Functions
| Client (const std::string &scheme_host_port)
| Client (const std::string &scheme_host_port, const std::string &client_cert_path, const std::string &client_key_path)
| Client (const std::string &host, int port)
| Client (const std::string &host, int port, const std::string &client_cert_path, const std::string &client_key_path)
| Client (Client &&)=default
Client & | operator= (Client &&)=default
| ~Client ()
bool | is_valid () const
Result | Get (const std::string &path, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, ResponseHandler response_handler, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Headers &headers, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Headers &headers, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Headers &headers, ResponseHandler response_handler, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Params &params, const Headers &headers, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Params &params, const Headers &headers, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Get (const std::string &path, const Params &params, const Headers &headers, ResponseHandler response_handler, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Head (const std::string &path)
Result | Head (const std::string &path, const Headers &headers)
Result | Post (const std::string &path)
Result | Post (const std::string &path, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Params &params)
Result | Post (const std::string &path, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers)
Result | Post (const std::string &path, const Headers &headers, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, const Params &params)
Result | Post (const std::string &path, const Headers &headers, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const std::string &boundary, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const FormDataProviderItems &provider_items, UploadProgress progress=nullptr)
Result | Post (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Put (const std::string &path)
Result | Put (const std::string &path, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Params &params)
Result | Put (const std::string &path, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers)
Result | Put (const std::string &path, const Headers &headers, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, const Params &params)
Result | Put (const std::string &path, const Headers &headers, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const std::string &boundary, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const FormDataProviderItems &provider_items, UploadProgress progress=nullptr)
Result | Put (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Patch (const std::string &path)
Result | Patch (const std::string &path, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Params &params)
Result | Patch (const std::string &path, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers)
Result | Patch (const std::string &path, const Headers &headers, const char *body, size_t content_length, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, size_t content_length, ContentProvider content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, ContentProviderWithoutLength content_provider, const std::string &content_type, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, const Params &params)
Result | Patch (const std::string &path, const Headers &headers, const UploadFormDataItems &items, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const std::string &boundary, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, const UploadFormDataItems &items, const FormDataProviderItems &provider_items, UploadProgress progress=nullptr)
Result | Patch (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, ContentReceiver content_receiver, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const char *body, size_t content_length, const std::string &content_type, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const std::string &body, const std::string &content_type, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const Params &params, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const Headers &headers, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const Headers &headers, const char *body, size_t content_length, const std::string &content_type, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const Headers &headers, const std::string &body, const std::string &content_type, DownloadProgress progress=nullptr)
Result | Delete (const std::string &path, const Headers &headers, const Params &params, DownloadProgress progress=nullptr)
Result | Options (const std::string &path)
Result | Options (const std::string &path, const Headers &headers)
bool | send (Request &req, Response &res, Error &error)
Result | send (const Request &req)
void | stop ()
std::string | host () const
int | port () const
size_t | is_socket_open () const
socket_t | socket () const
void | set_hostname_addr_map (std::map< std::string, std::string > addr_map)
void | set_default_headers (Headers headers)
void | set_header_writer (std::function< ssize_t(Stream &, Headers &)> const &writer)
void | set_address_family (int family)
void | set_tcp_nodelay (bool on)
void | set_socket_options (SocketOptions socket_options)
void | set_connection_timeout (time_t sec, time_t usec=0)
template<class Rep , class Period >
void | set_connection_timeout (const std::chrono::duration< Rep, Period > &duration)
void | set_read_timeout (time_t sec, time_t usec=0)
template<class Rep , class Period >
void | set_read_timeout (const std::chrono::duration< Rep, Period > &duration)
void | set_write_timeout (time_t sec, time_t usec=0)
template<class Rep , class Period >
void | set_write_timeout (const std::chrono::duration< Rep, Period > &duration)
void | set_max_timeout (time_t msec)
template<class Rep , class Period >
void | set_max_timeout (const std::chrono::duration< Rep, Period > &duration)
void | set_basic_auth (const std::string &username, const std::string &password)
void | set_bearer_token_auth (const std::string &token)
void | set_keep_alive (bool on)
void | set_follow_location (bool on)
void | set_path_encode (bool on)
void | set_url_encode (bool on)
void | set_compress (bool on)
void | set_decompress (bool on)
void | set_interface (const std::string &intf)
void | set_proxy (const std::string &host, int port)
void | set_proxy_basic_auth (const std::string &username, const std::string &password)
void | set_proxy_bearer_token_auth (const std::string &token)
void | set_logger (Logger logger)
void | set_error_logger (ErrorLogger error_logger)

## Detailed Description

Definition at line 1731 of file httplib.h.

## Constructor & Destructor Documentation

## ◆ Client() [1/5]

httplib::Client::Client | ( | const std::string & | scheme_host_port | ) |
| inline explicit

Definition at line 11285 of file httplib.h.

## ◆ Client() [2/5]

httplib::Client::Client | ( | const std::string & | scheme_host_port,
|  | const std::string & | client_cert_path,
|  | const std::string & | client_key_path
| ) |  |
| inline explicit

Definition at line 11288 of file httplib.h.

References host(), and port().

Here is the call graph for this function:

## ◆ Client() [3/5]

httplib::Client::Client | ( | const std::string & | host,
|  | int | port
| ) |  |
| inline explicit

Definition at line 11336 of file httplib.h.

## ◆ Client() [4/5]

httplib::Client::Client | ( | const std::string & | host,
|  | int | port,
|  | const std::string & | client_cert_path,
|  | const std::string & | client_key_path
| ) |  |
| inline explicit

Definition at line 11339 of file httplib.h.

## ◆ Client() [5/5]

httplib::Client::Client | ( | Client && |  | ) |
| default

## ◆ ~Client()

httplib::Client::~Client | ( |  | ) |
| inline default

## Member Function Documentation

## ◆ Delete() [1/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11699 of file httplib.h.

## ◆ Delete() [2/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11705 of file httplib.h.

## ◆ Delete() [3/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const Params & | params,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11727 of file httplib.h.

## ◆ Delete() [4/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11717 of file httplib.h.

## ◆ Delete() [5/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const Headers & | headers,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11695 of file httplib.h.

## ◆ Delete() [6/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const Params & | params,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11723 of file httplib.h.

## ◆ Delete() [7/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11712 of file httplib.h.

## ◆ Delete() [8/8]

Result httplib::Client::Delete | ( | const std::string & | path,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11691 of file httplib.h.

## ◆ Get() [1/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Headers & | headers,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11363 of file httplib.h.

## ◆ Get() [2/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Headers & | headers,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11354 of file httplib.h.

## ◆ Get() [3/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Headers & | headers,
|  | ResponseHandler | response_handler,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11376 of file httplib.h.

## ◆ Get() [4/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Params & | params,
|  | const Headers & | headers,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11387 of file httplib.h.

## ◆ Get() [5/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Params & | params,
|  | const Headers & | headers,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11383 of file httplib.h.

## ◆ Get() [6/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | const Params & | params,
|  | const Headers & | headers,
|  | ResponseHandler | response_handler,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11394 of file httplib.h.

## ◆ Get() [7/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11358 of file httplib.h.

## ◆ Get() [8/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11351 of file httplib.h.

## ◆ Get() [9/9]

Result httplib::Client::Get | ( | const std::string & | path,
|  | ResponseHandler | response_handler,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11369 of file httplib.h.

## ◆ Head() [1/2]

Result httplib::Client::Head | ( | const std::string & | path | ) |
| inline

Definition at line 11403 of file httplib.h.

## ◆ Head() [2/2]

Result httplib::Client::Head | ( | const std::string & | path,
|  | const Headers & | headers
| ) |  |
| inline

Definition at line 11404 of file httplib.h.

## ◆ host()

std::string httplib::Client::host | ( |  | ) | const
| inline

Definition at line 11747 of file httplib.h.

Referenced by Client(), and set_proxy().

Here is the caller graph for this function:

## ◆ is_socket_open()

size_t httplib::Client::is_socket_open | ( |  | ) | const
| inline

Definition at line 11751 of file httplib.h.

## ◆ is_valid()

bool httplib::Client::is_valid | ( |  | ) | const
| inline

Definition at line 11347 of file httplib.h.

## ◆ operator=()

Client & httplib::Client::operator= | ( | Client && |  | ) |
| default

## ◆ Options() [1/2]

Result httplib::Client::Options | ( | const std::string & | path | ) |
| inline

Definition at line 11732 of file httplib.h.

## ◆ Options() [2/2]

Result httplib::Client::Options | ( | const std::string & | path,
|  | const Headers & | headers
| ) |  |
| inline

Definition at line 11735 of file httplib.h.

## ◆ Patch() [1/17]

Result httplib::Client::Patch | ( | const std::string & | path | ) |
| inline

Definition at line 11595 of file httplib.h.

## ◆ Patch() [2/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11601 of file httplib.h.

## ◆ Patch() [3/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers
| ) |  |
| inline

Definition at line 11598 of file httplib.h.

## ◆ Patch() [4/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11607 of file httplib.h.

## ◆ Patch() [5/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11656 of file httplib.h.

## ◆ Patch() [6/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11682 of file httplib.h.

## ◆ Patch() [7/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11619 of file httplib.h.

## ◆ Patch() [8/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const FormDataProviderItems & | provider_items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11676 of file httplib.h.

## ◆ Patch() [9/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const std::string & | boundary,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11670 of file httplib.h.

## ◆ Patch() [10/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11665 of file httplib.h.

## ◆ Patch() [11/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11646 of file httplib.h.

## ◆ Patch() [12/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Headers & | headers,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11638 of file httplib.h.

## ◆ Patch() [13/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11653 of file httplib.h.

## ◆ Patch() [14/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11614 of file httplib.h.

## ◆ Patch() [15/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11660 of file httplib.h.

## ◆ Patch() [16/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11632 of file httplib.h.

## ◆ Patch() [17/17]

Result httplib::Client::Patch | ( | const std::string & | path,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11625 of file httplib.h.

## ◆ port()

int httplib::Client::port | ( |  | ) | const
| inline

Definition at line 11749 of file httplib.h.

Referenced by Client(), and set_proxy().

Here is the caller graph for this function:

## ◆ Post() [1/17]

Result httplib::Client::Post | ( | const std::string & | path | ) |
| inline

Definition at line 11408 of file httplib.h.

## ◆ Post() [2/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11412 of file httplib.h.

## ◆ Post() [3/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers
| ) |  |
| inline

Definition at line 11409 of file httplib.h.

## ◆ Post() [4/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11418 of file httplib.h.

## ◆ Post() [5/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11467 of file httplib.h.

## ◆ Post() [6/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11493 of file httplib.h.

## ◆ Post() [7/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11430 of file httplib.h.

## ◆ Post() [8/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const FormDataProviderItems & | provider_items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11487 of file httplib.h.

## ◆ Post() [9/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const std::string & | boundary,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11481 of file httplib.h.

## ◆ Post() [10/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11476 of file httplib.h.

## ◆ Post() [11/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11457 of file httplib.h.

## ◆ Post() [12/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Headers & | headers,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11449 of file httplib.h.

## ◆ Post() [13/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11464 of file httplib.h.

## ◆ Post() [14/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11425 of file httplib.h.

## ◆ Post() [15/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11471 of file httplib.h.

## ◆ Post() [16/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11443 of file httplib.h.

## ◆ Post() [17/17]

Result httplib::Client::Post | ( | const std::string & | path,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11436 of file httplib.h.

## ◆ Put() [1/17]

Result httplib::Client::Put | ( | const std::string & | path | ) |
| inline

Definition at line 11502 of file httplib.h.

## ◆ Put() [2/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11506 of file httplib.h.

## ◆ Put() [3/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers
| ) |  |
| inline

Definition at line 11503 of file httplib.h.

## ◆ Put() [4/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const char * | body,
|  | size_t | content_length,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11512 of file httplib.h.

## ◆ Put() [5/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11560 of file httplib.h.

## ◆ Put() [6/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | ContentReceiver | content_receiver,
|  | DownloadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11586 of file httplib.h.

## ◆ Put() [7/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11523 of file httplib.h.

## ◆ Put() [8/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const FormDataProviderItems & | provider_items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11580 of file httplib.h.

## ◆ Put() [9/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | const std::string & | boundary,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11574 of file httplib.h.

## ◆ Put() [10/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11569 of file httplib.h.

## ◆ Put() [11/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11550 of file httplib.h.

## ◆ Put() [12/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Headers & | headers,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11542 of file httplib.h.

## ◆ Put() [13/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const Params & | params
| ) |  |
| inline

Definition at line 11557 of file httplib.h.

## ◆ Put() [14/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const std::string & | body,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11518 of file httplib.h.

## ◆ Put() [15/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | const UploadFormDataItems & | items,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11564 of file httplib.h.

## ◆ Put() [16/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | ContentProviderWithoutLength | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11536 of file httplib.h.

## ◆ Put() [17/17]

Result httplib::Client::Put | ( | const std::string & | path,
|  | size_t | content_length,
|  | ContentProvider | content_provider,
|  | const std::string & | content_type,
|  | UploadProgress | progress = `nullptr`
| ) |  |
| inline

Definition at line 11529 of file httplib.h.

## ◆ send() [1/2]

Result httplib::Client::send | ( | const Request & | req | ) |
| inline

Definition at line 11743 of file httplib.h.

## ◆ send() [2/2]

bool httplib::Client::send | ( | Request & | req,
|  | Response & | res,
|  | Error & | error
| ) |  |
| inline

Definition at line 11739 of file httplib.h.

## ◆ set_address_family()

void httplib::Client::set_address_family | ( | int | family | ) |
| inline

Definition at line 11769 of file httplib.h.

## ◆ set_basic_auth()

void httplib::Client::set_basic_auth | ( | const std::string & | username,
|  | const std::string & | password
| ) |  |
| inline

Definition at line 11791 of file httplib.h.

## ◆ set_bearer_token_auth()

void httplib::Client::set_bearer_token_auth | ( | const std::string & | token | ) |
| inline

Definition at line 11795 of file httplib.h.

## ◆ set_compress()

void httplib::Client::set_compress | ( | bool | on | ) |
| inline

Definition at line 11817 of file httplib.h.

## ◆ set_connection_timeout() [1/2]

template<class Rep , class Period >

void httplib::Client::set_connection_timeout | ( | const std::chrono::duration< Rep, Period > & | duration | ) |
| inline

Definition at line 2325 of file httplib.h.

## ◆ set_connection_timeout() [2/2]

void httplib::Client::set_connection_timeout | ( | time_t | sec,
|  | time_t | usec = `0`
| ) |  |
| inline

Definition at line 11779 of file httplib.h.

## ◆ set_decompress()

void httplib::Client::set_decompress | ( | bool | on | ) |
| inline

Definition at line 11819 of file httplib.h.

## ◆ set_default_headers()

void httplib::Client::set_default_headers | ( | Headers | headers | ) |
| inline

Definition at line 11760 of file httplib.h.

## ◆ set_error_logger()

void httplib::Client::set_error_logger | ( | ErrorLogger | error_logger | ) |
| inline

Definition at line 11861 of file httplib.h.

## ◆ set_follow_location()

void httplib::Client::set_follow_location | ( | bool | on | ) |
| inline

Definition at line 11806 of file httplib.h.

## ◆ set_header_writer()

void httplib::Client::set_header_writer | ( | std::function< ssize_t(Stream &, Headers &)> const & | writer | ) |
| inline

Definition at line 11764 of file httplib.h.

## ◆ set_hostname_addr_map()

void httplib::Client::set_hostname_addr_map | ( | std::map< std::string, std::string > | addr_map | ) |
| inline

Definition at line 11756 of file httplib.h.

## ◆ set_interface()

void httplib::Client::set_interface | ( | const std::string & | intf | ) |
| inline

Definition at line 11821 of file httplib.h.

## ◆ set_keep_alive()

void httplib::Client::set_keep_alive | ( | bool | on | ) |
| inline

Definition at line 11805 of file httplib.h.

## ◆ set_logger()

void httplib::Client::set_logger | ( | Logger | logger | ) |
| inline

Definition at line 11857 of file httplib.h.

## ◆ set_max_timeout() [1/2]

template<class Rep , class Period >

void httplib::Client::set_max_timeout | ( | const std::chrono::duration< Rep, Period > & | duration | ) |
| inline

Definition at line 2348 of file httplib.h.

## ◆ set_max_timeout() [2/2]

void httplib::Client::set_max_timeout | ( | time_t | msec | ) |
| inline

Definition at line 2342 of file httplib.h.

## ◆ set_path_encode()

void httplib::Client::set_path_encode | ( | bool | on | ) |
| inline

Definition at line 11810 of file httplib.h.

## ◆ set_proxy()

void httplib::Client::set_proxy | ( | const std::string & | host,
|  | int | port
| ) |  |
| inline

Definition at line 11825 of file httplib.h.

References host(), and port().

Here is the call graph for this function:

## ◆ set_proxy_basic_auth()

void httplib::Client::set_proxy_basic_auth | ( | const std::string & | username,
|  | const std::string & | password
| ) |  |
| inline

Definition at line 11828 of file httplib.h.

## ◆ set_proxy_bearer_token_auth()

void httplib::Client::set_proxy_bearer_token_auth | ( | const std::string & | token | ) |
| inline

Definition at line 11832 of file httplib.h.

## ◆ set_read_timeout() [1/2]

template<class Rep , class Period >

void httplib::Client::set_read_timeout | ( | const std::chrono::duration< Rep, Period > & | duration | ) |
| inline

Definition at line 2332 of file httplib.h.

## ◆ set_read_timeout() [2/2]

void httplib::Client::set_read_timeout | ( | time_t | sec,
|  | time_t | usec = `0`
| ) |  |
| inline

Definition at line 11783 of file httplib.h.

## ◆ set_socket_options()

void httplib::Client::set_socket_options | ( | SocketOptions | socket_options | ) |
| inline

Definition at line 11775 of file httplib.h.

## ◆ set_tcp_nodelay()

void httplib::Client::set_tcp_nodelay | ( | bool | on | ) |
| inline

Definition at line 11773 of file httplib.h.

## ◆ set_url_encode()

void httplib::Client::set_url_encode | ( | bool | on | ) |
| inline

Definition at line 11813 of file httplib.h.

## ◆ set_write_timeout() [1/2]

template<class Rep , class Period >

void httplib::Client::set_write_timeout | ( | const std::chrono::duration< Rep, Period > & | duration | ) |
| inline

Definition at line 2338 of file httplib.h.

## ◆ set_write_timeout() [2/2]

void httplib::Client::set_write_timeout | ( | time_t | sec,
|  | time_t | usec = `0`
| ) |  |
| inline

Definition at line 11787 of file httplib.h.

## ◆ socket()

socket_t httplib::Client::socket | ( |  | ) | const
| inline

Definition at line 11753 of file httplib.h.

## ◆ stop()

void httplib::Client::stop | ( |  | ) |
| inline

Definition at line 11745 of file httplib.h.

The documentation for this class was generated from the following file:

- integrations/rest_api/httplib.h